function [matrix_indexes_son, wheretolook_son] = build_state_sons(n_pos,n_hc,n_net,n_es,n_occ,matrix_indexes_father)


% Build state for sons:
% 14 Variables: 

n_fat_here=1;
%%%%%%%%%%%%%%%%%%%% FOR CELLS WITH FH=1 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 1) Start will small matrix
[j1_ind_son, j2_ind_son, j3_ind_son]=ind2sub([n_pos n_fat_here n_pos],1:n_pos*n_fat_here*n_pos);
matrix_indexes_son=[j1_ind_son' j2_ind_son' j3_ind_son'];

    % Matrix of positions:
    pos = [1 1 1; 1 0 0; 0 1 0; 0 0 1; 0 0 0];
    sum_pos=sum(pos(:,1:2),2);
    
    % Prepare matrix for the state;   
    matrix_indexes_son = [[1:n_pos*n_fat_here*n_pos]' matrix_indexes_son];
    
    % Now, using the positions, compute how many copies we should do of
    % each row:
    rows_to_add=[];
    for j=1:n_pos*n_fat_here*n_pos
        % check how many 0's:
        sum_Y=sum_pos(matrix_indexes_son(j,2))+sum_pos(matrix_indexes_son(j,4));
        if sum_Y==4    % (0 N's)
            % Then I know everything: 0 copies
        elseif sum_Y==3   % (1 N's)
            % Then I know everything: 0 copies
        elseif sum_Y==2   % (2 N's)          
             if pos(matrix_indexes_son(j,2),3)==1 ||  pos(matrix_indexes_son(j,4),3)==1     % Check if the two N's are for same person
            % Then I know everything: 0 copies
             else                                                                           % Then it's for the two diff. people
            % Then I have 2 cases: 1 copy
             rows_to_add=[repmat(matrix_indexes_son(j,:),1,1); rows_to_add];
             end
        elseif sum_Y==1   % (3 N's)
            if pos(matrix_indexes_son(j,2),3)==1 ||  pos(matrix_indexes_son(j,4),3)==1     % Check if we're in case NNC
             % Then I have 2 cases: 1 copy
             rows_to_add=[repmat(matrix_indexes_son(j,:),1,1); rows_to_add];
            else                                                                           % Then we're in case NNN
             % Then I have 3 cases: 2 copies
             rows_to_add=[repmat(matrix_indexes_son(j,:),2,1); rows_to_add];        
            end
        elseif sum_Y==0   % (4 N's)
            if pos(matrix_indexes_son(j,2),3)==1 &&  pos(matrix_indexes_son(j,4),3)==1     % Check if we're in case NNC-NNC            
             % Then I have 2 cases: 1 copy
             rows_to_add=[repmat(matrix_indexes_son(j,:),1,1); rows_to_add];
            elseif pos(matrix_indexes_son(j,2),3)+pos(matrix_indexes_son(j,4),3)==1        % Check if we're in case NNC-NNN (or viceversa)
             % Then I have 3 cases: 2 copies
             rows_to_add=[repmat(matrix_indexes_son(j,:),2,1); rows_to_add];  
            elseif pos(matrix_indexes_son(j,2),3)+pos(matrix_indexes_son(j,4),3)==0        % Check if we're in case NNN-NNN 
             % Then I have 7 cases: 6 copies
             rows_to_add=[repmat(matrix_indexes_son(j,:),6,1); rows_to_add];               
            end
         end
    end
% 2) Expand the rows as you need and sort rows according to structure of state
     matrix_indexes_son= [rows_to_add(:,2:4);
                          matrix_indexes_son(:,2:4)];
     matrix_indexes_son=sortrows(matrix_indexes_son, [3 2 1]);
% 3) Add remaining variables
     length=size(matrix_indexes_son,1);
     matrix_indexes_son= [matrix_indexes_son 999*ones(length,4)];
     % Counter of copies:
    num_cop=ones(length,1);
    for j=2:length
    num_cop(j)=num_cop(j)+num_cop(j-1)*min(matrix_indexes_son(j,:)==matrix_indexes_son(j-1,:));
    end
     % Now replace the elements:
    matrix_indexes_son = [[1:length]' matrix_indexes_son];
    for j=1:length
        % check how many 0's:
        sum_Y=sum_pos(matrix_indexes_son(j,2))+sum_pos(matrix_indexes_son(j,4));
          matrix_indexes_son(j,5:8)=[pos(matrix_indexes_son(j,2),1)*pos(matrix_indexes_son(j,4),1);                     % Here we "pretend" we know everything
                                pos(matrix_indexes_son(j,2),2)*pos(matrix_indexes_son(j,4),2);
                                pos(matrix_indexes_son(j,2),1)*pos(matrix_indexes_son(j,4),2);
                                pos(matrix_indexes_son(j,2),2)*pos(matrix_indexes_son(j,4),1)]'; 

        if sum_Y==4    % (0 N's)
            % Nothing to correct
        elseif sum_Y==3   % (1 N's)
            % Nothing to correct
        elseif sum_Y==2   % (2 N's)          
                         if num_cop(j)==1
                         matrix_indexes_son(j,5:8)=matrix_indexes_son(j,5:8) + (ones(1,4)-matrix_indexes_son(j,5:8)).*...   % Here we correct for first copies
                                                        ([pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),1);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),1)]==[0;0;0;0])';
                         elseif num_cop(j)==2
                         matrix_indexes_son(j,5:8)=matrix_indexes_son(j,5:8) + (zeros(1,4)-matrix_indexes_son(j,5:8)).*...  % Here we correct for second copies
                                                        ([pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),1);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),1)]==[0;0;0;0])';                     
                         end
          elseif sum_Y==1   % (3 N's)
              if pos(matrix_indexes_son(j,2),3)==1 ||  pos(matrix_indexes_son(j,4),3)==1     % Check if we're in case NNC
                         if num_cop(j)==1
                         matrix_indexes_son(j,5:8)=matrix_indexes_son(j,5:8) + (ones(1,4)-matrix_indexes_son(j,5:8)).*...   % Here we correct for first copies
                                                        ([pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),1);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),1)]==[0;0;0;0])';
                         elseif num_cop(j)==2
                         matrix_indexes_son(j,5:8)=matrix_indexes_son(j,5:8) + (zeros(1,4)-matrix_indexes_son(j,5:8)).*...  % Here we correct for second copies
                                                        ([pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),1);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),1)]==[0;0;0;0])';                     
                         end
             else                                                                           % Then we're in case NNN
                    if pos(matrix_indexes_son(j,2),1)==1
                       var1=6;
                       var2=8;
                    elseif pos(matrix_indexes_son(j,2),2)==1
                       var1=5;
                       var2=7;                       
                    elseif pos(matrix_indexes_son(j,4),1)==1
                       var1=6;
                       var2=7;                       
                    elseif pos(matrix_indexes_son(j,4),2)==1   
                       var1=5;
                       var2=8;                          
                    end
                    
                    if num_cop(j)==1
                    matrix_indexes_son(j,var1)=1;
                    matrix_indexes_son(j,var2)=0;
                    elseif num_cop(j)==2
                    matrix_indexes_son(j,var1)=0;
                    matrix_indexes_son(j,var2)=1;                        
                    elseif num_cop(j)==3
                    matrix_indexes_son(j,var1)=0;
                    matrix_indexes_son(j,var2)=0;                        
                    end
              end
            elseif sum_Y==0   % (4 N's)
                 if pos(matrix_indexes_son(j,2),3)==1 &&  pos(matrix_indexes_son(j,4),3)==1     % Check if we're in case NNC-NNC      
                     if num_cop(j)==1
                         matrix_indexes_son(j,5:8)=[1;1;1;1];
                     elseif num_cop(j)==2
                         matrix_indexes_son(j,5:8)=[0;0;0;0];
                     end
             elseif pos(matrix_indexes_son(j,2),3)+pos(matrix_indexes_son(j,4),3)==1       % Check if we're in case NNC-NNN (or viceversa)
                        if pos(matrix_indexes_son(j,2),3)==1                               % Case NNC-NNN 
                           var1=5;var2=8;var3=6;var4=7;
                        elseif pos(matrix_indexes_son(j,4),3)==1                           % Case NNN-NNC 
                           var1=5;var2=7;var3=6;var4=8;
                        end
                                    if num_cop(j)==1
                                    matrix_indexes_son(j,var1)=1;
                                    matrix_indexes_son(j,var2)=1;
                                    elseif num_cop(j)==2
                                    matrix_indexes_son(j,var3)=1;
                                    matrix_indexes_son(j,var4)=1; 
                                    elseif num_cop(j)==3
                                    matrix_indexes_son(j,var1)=0;
                                    matrix_indexes_son(j,var2)=0; 
                                    matrix_indexes_son(j,var3)=0;
                                    matrix_indexes_son(j,var4)=0; 
                                    end
             elseif pos(matrix_indexes_son(j,2),3)+pos(matrix_indexes_son(j,4),3)==0        % Check if we're in case NNN-NNN 
                    if num_cop(j)==1
                      matrix_indexes_son(j,5:8)=[1;0;0;0];   
                    elseif num_cop(j)==2
                      matrix_indexes_son(j,5:8)=[0;1;0;0];   
                    elseif num_cop(j)==3
                      matrix_indexes_son(j,5:8)=[0;0;1;0];                   
                    elseif num_cop(j)==4
                      matrix_indexes_son(j,5:8)=[0;0;0;1];                  
                    elseif num_cop(j)==5
                      matrix_indexes_son(j,5:8)=[1;1;0;0];             
                    elseif num_cop(j)==6
                      matrix_indexes_son(j,5:8)=[0;0;1;1];          
                    elseif num_cop(j)==7
                      matrix_indexes_son(j,5:8)=[0;0;0;0]; 
                    end     
                 end
            end
    end
     
% 4) Now ADD x9, x10, x11 and x12:
     matrix_indexes_son= [matrix_indexes_son 999*ones(length,2)];
     matrix_indexes_son(:,9)=pos(matrix_indexes_son(:,2),1);  
     matrix_indexes_son(:,10)=pos(matrix_indexes_son(:,2),2);    
     matrix_indexes_son(:,11)=pos(matrix_indexes_son(:,4),1);  
     matrix_indexes_son(:,12)=pos(matrix_indexes_son(:,4),2);
matrix_indexes_son_HF0=matrix_indexes_son;

%%%%%%%%%%%%%%%%%%%% FOR CELLS WITH FH=2 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% 1) Start will small matrix
[j1_ind_son, j2_ind_son, j3_ind_son]=ind2sub([n_pos n_fat_here n_pos],1:n_pos*n_fat_here*n_pos);
matrix_indexes_son=[j1_ind_son' j2_ind_son' j3_ind_son'];
matrix_indexes_son(:,2)=2*ones(size(matrix_indexes_son,1),1);  % set FH=2;

    % Matrix of positions:
    pos = [1 1 1; 1 0 0; 0 1 0; 0 0 1; 0 0 0];
    sum_pos=sum(pos(:,1:2),2);
    
    % Prepare matrix for the state;   
    matrix_indexes_son = [[1:n_pos*n_fat_here*n_pos]' matrix_indexes_son];
    
    % Now, using the positions, compute how many copies we should do of
    % each row:
    rows_to_add=[];
    for j=1:n_pos*n_fat_here*n_pos
        % check how many 0's:
        sum_Y=sum_pos(matrix_indexes_son(j,2))+sum_pos(matrix_indexes_son(j,4));
        if sum_Y==4    % (0 N's)
            % Then I know everything: 0 copies
        elseif sum_Y==3   % (1 N's)
            % Then I have 2 cases: 1 copy
            rows_to_add=[repmat(matrix_indexes_son(j,:),1,1); rows_to_add];
        elseif sum_Y==2   % (2 N's)          
                         if sum_pos(matrix_indexes_son(j,2))==0 && pos(matrix_indexes_son(j,2),3)==1 || sum_pos(matrix_indexes_son(j,4))==0 &&  pos(matrix_indexes_son(j,4),3)==1     % Check if the two N's are for same person (NNC-... or ...-NNC)
                        % Then I have 2 cases: 1 copy
                         rows_to_add=[repmat(matrix_indexes_son(j,:),1,1); rows_to_add];
                         elseif ((pos(matrix_indexes_son(j,2),1)+ pos(matrix_indexes_son(j,2),2))==0) && pos(matrix_indexes_son(j,2),3)==0     % (NNN-...)
                        % Then I have 3 cases: 2 copies
                         rows_to_add=[repmat(matrix_indexes_son(j,:),2,1); rows_to_add];
                         elseif ((pos(matrix_indexes_son(j,4),1)+ pos(matrix_indexes_son(j,4),2))==0) && pos(matrix_indexes_son(j,4),3)==0     % (...-NNN)
                        % Then I have 3 cases: 2 copies
                         rows_to_add=[repmat(matrix_indexes_son(j,:),2,1); rows_to_add];
                         else                                                                         % Then the two N's are of diff.people
                        % Then I have 5 cases: 4 copies
                         rows_to_add=[repmat(matrix_indexes_son(j,:),4,1); rows_to_add];
                         end

        elseif sum_Y==1   % (3 N's)
            if pos(matrix_indexes_son(j,2),3)==1                                            % Check if we're in case NNC - ...
             % Then I have 5 cases: 4 copies
             rows_to_add=[repmat(matrix_indexes_son(j,:),4,1); rows_to_add];                
            elseif pos(matrix_indexes_son(j,4),3)==1                                        % Check if we're in case ... - NNC                   
             % Then I have 5 cases: 4 copies
             rows_to_add=[repmat(matrix_indexes_son(j,:),4,1); rows_to_add];
            else                                                                           % Then we're in case NNN
                            if pos(matrix_indexes_son(j,2),1)+ pos(matrix_indexes_son(j,2),2)==0   % NNN-...
                                % Then I have 10 cases: 9 copies           
                                    rows_to_add=[repmat(matrix_indexes_son(j,:),9,1); rows_to_add];
                            else                                                                   %...-NNN
                                % Then I have 10 cases: 9 copies
                                    rows_to_add=[repmat(matrix_indexes_son(j,:),9,1); rows_to_add];   
                            end
            end
        elseif sum_Y==0   % (4 N's)
            if pos(matrix_indexes_son(j,2),3)==1 &&  pos(matrix_indexes_son(j,4),3)==1     % Check if we're in case NNC-NNC            
             % Then I have 5 cases: 4 copies
             rows_to_add=[repmat(matrix_indexes_son(j,:),4,1); rows_to_add];
            elseif pos(matrix_indexes_son(j,2),3)==1 &&  pos(matrix_indexes_son(j,4),3)==0       % Check if we're in case NNC-NNN 
             % Then I have 10 cases: 9 copies
             rows_to_add=[repmat(matrix_indexes_son(j,:),9,1); rows_to_add];  
            elseif pos(matrix_indexes_son(j,2),3)==0 &&  pos(matrix_indexes_son(j,4),3)==1       % Check if we're in case NNN-NNC 
             % Then I have 10 cases: 9 copies
             rows_to_add=[repmat(matrix_indexes_son(j,:),9,1); rows_to_add];              
            elseif pos(matrix_indexes_son(j,2),3)+pos(matrix_indexes_son(j,4),3)==0        % Check if we're in case NNN-NNN 
             % Then I have 27 cases: 26 copies
             rows_to_add=[repmat(matrix_indexes_son(j,:),26,1); rows_to_add];               
            end
         end
    end
% 2) Expand the rows as you need and sort rows according to structure of state
     matrix_indexes_son= [rows_to_add(:,2:4);
                          matrix_indexes_son(:,2:4)];
     matrix_indexes_son=sortrows(matrix_indexes_son, [3 2 1]);

% 3) Add remaining variables
     length=size(matrix_indexes_son,1);
     matrix_indexes_son= [matrix_indexes_son 999*ones(length,4)];
     % Counter of copies:
    num_cop=ones(length,1);
    for j=2:length
    num_cop(j)=num_cop(j)+num_cop(j-1)*min(matrix_indexes_son(j,:)==matrix_indexes_son(j-1,:));
    end
     % Now replace the elements:
    matrix_indexes_son = [[1:length]' matrix_indexes_son];
    for j=1:length
        % check how many 0's:
        sum_Y=sum_pos(matrix_indexes_son(j,2))+sum_pos(matrix_indexes_son(j,4));
          matrix_indexes_son(j,5:8)=[0;0;0;0]';   % Start by default with all 0's
         if sum_Y==4    % (0 N's)
            % Nothing to correct
         elseif sum_Y==3   % (1 N's)
                         if num_cop(j)==1
                         matrix_indexes_son(j,5:8)=matrix_indexes_son(j,5:8) + (ones(1,4)-matrix_indexes_son(j,5:8)).*...   % Here we correct for first copies
                                                        ([pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),1);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),1)]==[1;1;1;1])';
                         elseif num_cop(j)==2
                         matrix_indexes_son(j,5:8)=matrix_indexes_son(j,5:8) + (zeros(1,4)-matrix_indexes_son(j,5:8)).*...  % Here we correct for second copies
                                                        ([pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),1);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),1)+pos(matrix_indexes_son(j,4),2);
                                                        pos(matrix_indexes_son(j,2),2)+pos(matrix_indexes_son(j,4),1)]==[1;1;1;1])';                     
                         end
         elseif sum_Y==2   % (2 N's)   
                   if (sum_pos(matrix_indexes_son(j,2))==0) && (pos(matrix_indexes_son(j,2),3)==1) || (sum_pos(matrix_indexes_son(j,4))==0) && (pos(matrix_indexes_son(j,4),3)==1)    % Check if the two N's are for same person
                          if num_cop(j)==1
                             matrix_indexes_son(j,5:8)=[1;1;1;1];
                          elseif num_cop(j)==2
                              matrix_indexes_son(j,5:8)=[0;0;0;0];
                          end
                   elseif pos(matrix_indexes_son(j,2),1)==0 && pos(matrix_indexes_son(j,2),2)==0 && pos(matrix_indexes_son(j,2),3)==0      % Check if it's NNN-...  
                        var1=5;var2=7;var3=6;var4=8;
                          if num_cop(j)==1
                             matrix_indexes_son(j,var1)=1;
                             matrix_indexes_son(j,var2)=1;
                          elseif num_cop(j)==2
                             matrix_indexes_son(j,var3)=1;
                             matrix_indexes_son(j,var4)=1;
                          elseif num_cop(j)==3
                          % Do nothing       
                          end
                   elseif pos(matrix_indexes_son(j,4),1)==0 && pos(matrix_indexes_son(j,4),2)==0 && pos(matrix_indexes_son(j,4),3)==0      % Check if it's ...-NNN  
                        var1=5;var2=8;var3=6;var4=7;
                          if num_cop(j)==1
                             matrix_indexes_son(j,var1)=1;
                             matrix_indexes_son(j,var2)=1;
                          elseif num_cop(j)==2
                             matrix_indexes_son(j,var3)=1;
                             matrix_indexes_son(j,var4)=1;
                          elseif num_cop(j)==3
                          % Do nothing       
                          end
                   elseif pos(matrix_indexes_son(j,2),2)==0 && pos(matrix_indexes_son(j,4),2)==0     % YN-YN
                        var1=6;var2=7;var3=8;
                          if num_cop(j)==1
                             matrix_indexes_son(j,var2)=1;
                             matrix_indexes_son(j,var3)=1;
                          elseif num_cop(j)==2
                             matrix_indexes_son(j,var1)=1;
                          elseif num_cop(j)==3
                             matrix_indexes_son(j,var2)=1;
                          elseif num_cop(j)==4
                             matrix_indexes_son(j,var3)=1;   
                          elseif num_cop(j)==5
                             % Do nothing
                          end                          
                   elseif pos(matrix_indexes_son(j,2),2)==0 && pos(matrix_indexes_son(j,4),1)==0     % YN-NY
                        var1=5;var2=6;var3=8;
                          if num_cop(j)==1
                             matrix_indexes_son(j,var1)=1;
                             matrix_indexes_son(j,var2)=1;
                          elseif num_cop(j)==2
                             matrix_indexes_son(j,var1)=1;
                          elseif num_cop(j)==3
                             matrix_indexes_son(j,var2)=1;
                          elseif num_cop(j)==4
                             matrix_indexes_son(j,var3)=1;   
                          elseif num_cop(j)==5
                             % Do nothing
                          end       
                   elseif pos(matrix_indexes_son(j,2),1)==0 && pos(matrix_indexes_son(j,4),2)==0     % NY-YN
                        var1=5;var2=6;var3=7;
                          if num_cop(j)==1
                             matrix_indexes_son(j,var1)=1;
                             matrix_indexes_son(j,var2)=1;
                          elseif num_cop(j)==2
                             matrix_indexes_son(j,var1)=1;
                          elseif num_cop(j)==3
                             matrix_indexes_son(j,var2)=1;
                          elseif num_cop(j)==4
                             matrix_indexes_son(j,var3)=1;   
                          elseif num_cop(j)==5
                             % Do nothing
                          end       
                   elseif pos(matrix_indexes_son(j,2),1)==0 && pos(matrix_indexes_son(j,4),1)==0     % NY-NY
                        var1=5;var2=7;var3=8;
                          if num_cop(j)==1
                             matrix_indexes_son(j,var2)=1;
                             matrix_indexes_son(j,var3)=1;
                          elseif num_cop(j)==2
                             matrix_indexes_son(j,var1)=1;
                          elseif num_cop(j)==3
                             matrix_indexes_son(j,var2)=1;
                          elseif num_cop(j)==4
                             matrix_indexes_son(j,var3)=1;   
                          elseif num_cop(j)==5
                             % Do nothing
                          end   
                   end
           elseif sum_Y==1   % (3 N's)
               
                 if pos(matrix_indexes_son(j,2),3)==1                                            % Check if we're in case NNC - ...
                       if pos(matrix_indexes_son(j,4),1)==1                                          % NNC -YN
                                   if num_cop(j)==1
                                     matrix_indexes_son(j,5)=1;
                                     matrix_indexes_son(j,8)=1;
                                  elseif num_cop(j)==2
                                     matrix_indexes_son(j,5)=1;
                                     matrix_indexes_son(j,8)=1;
                                  elseif num_cop(j)==3
                                     matrix_indexes_son(j,6)=1;
                                     matrix_indexes_son(j,7)=1;
                                  elseif num_cop(j)==4
                                  % Do nothing  
                                  elseif num_cop(j)==5
                                  % Do nothing
                                  end    
                       elseif pos(matrix_indexes_son(j,4),2)==1                                   % NNC -NY
                                   if num_cop(j)==1
                                     matrix_indexes_son(j,5)=1;
                                     matrix_indexes_son(j,8)=1;
                                  elseif num_cop(j)==2
                                     matrix_indexes_son(j,6)=1;
                                     matrix_indexes_son(j,7)=1;
                                  elseif num_cop(j)==3
                                     matrix_indexes_son(j,6)=1;
                                     matrix_indexes_son(j,7)=1;
                                  elseif num_cop(j)==4
                                  % Do nothing  
                                  elseif num_cop(j)==5
                                  % Do nothing
                                  end                          

                       end
                                  
                elseif pos(matrix_indexes_son(j,4),3)==1                                        % Check if we're in case ... - NNC    
                        if pos(matrix_indexes_son(j,2),2)==0                                    % Case YN-NNC
                                    if num_cop(j)==1
                                     matrix_indexes_son(j,5)=1;
                                     matrix_indexes_son(j,7)=1;
                                  elseif num_cop(j)==2
                                     matrix_indexes_son(j,5)=1;
                                     matrix_indexes_son(j,7)=1;
                                  elseif num_cop(j)==3
                                     matrix_indexes_son(j,6)=1;
                                     matrix_indexes_son(j,8)=1;  
                                  elseif num_cop(j)==4 || num_cop(j)==5
                                         % Do nothing
                                  end                          
                            
                        end
                        if pos(matrix_indexes_son(j,2),1)==0                                    % Case NY-NNC
                                    if num_cop(j)==1
                                     matrix_indexes_son(j,5)=1;
                                     matrix_indexes_son(j,7)=1;
                                  elseif num_cop(j)==2
                                     matrix_indexes_son(j,6)=1;
                                     matrix_indexes_son(j,8)=1;
                                  elseif num_cop(j)==3
                                     matrix_indexes_son(j,6)=1;
                                     matrix_indexes_son(j,8)=1;  
                                  elseif num_cop(j)==4 || num_cop(j)==5
                                         % Do nothing
                                  end                          
                            
                        end
                 elseif pos(matrix_indexes_son(j,2),1)==0  && pos(matrix_indexes_son(j,2),2)==0  && pos(matrix_indexes_son(j,2),3)==0    % Case NNN-...
                     if pos(matrix_indexes_son(j,4),1)==1                                          % NNN -YN
                                    if num_cop(j)==1
                                     matrix_indexes_son(j,5)=1;
                                    elseif num_cop(j)==2
                                     matrix_indexes_son(j,5)=1;
                                    elseif num_cop(j)==3
                                     matrix_indexes_son(j,6)=1; 
                                    elseif num_cop(j)==4 
                                     matrix_indexes_son(j,7)=1; 
                                    elseif num_cop(j)==5
                                     matrix_indexes_son(j,8)=1;
                                    elseif num_cop(j)==6
                                     matrix_indexes_son(j,8)=1;                                        
                                    elseif num_cop(j)==7
                                     matrix_indexes_son(j,5)=1;  
                                     matrix_indexes_son(j,6)=1;  
                                    elseif num_cop(j)==8
                                     matrix_indexes_son(j,7)=1;  
                                     matrix_indexes_son(j,8)=1;
                                     elseif num_cop(j)==9
                                     % Do nothing
                                     elseif num_cop(j)==10
                                     % Do nothing
                                    end     
                     elseif pos(matrix_indexes_son(j,4),2)==1                                          % NNN -NY
                                    if num_cop(j)==1
                                     matrix_indexes_son(j,5)=1;
                                    elseif num_cop(j)==2
                                     matrix_indexes_son(j,6)=1;
                                    elseif num_cop(j)==3
                                     matrix_indexes_son(j,6)=1; 
                                    elseif num_cop(j)==4 
                                     matrix_indexes_son(j,7)=1; 
                                    elseif num_cop(j)==5
                                     matrix_indexes_son(j,7)=1;
                                    elseif num_cop(j)==6
                                     matrix_indexes_son(j,8)=1;                                        
                                    elseif num_cop(j)==7
                                     matrix_indexes_son(j,5)=1;  
                                     matrix_indexes_son(j,6)=1;  
                                    elseif num_cop(j)==8
                                     matrix_indexes_son(j,7)=1;  
                                     matrix_indexes_son(j,8)=1;
                                     elseif num_cop(j)==9
                                     % Do nothing
                                     elseif num_cop(j)==10
                                     % Do nothing
                                    end                             
                     end
                  elseif pos(matrix_indexes_son(j,4),1)==0  && pos(matrix_indexes_son(j,4),2)==0  && pos(matrix_indexes_son(j,4),3)==0    % Case ...-NNN                      
                            if pos(matrix_indexes_son(j,2),1)==1                                                       % YN-NNN
                                    if num_cop(j)==1
                                     matrix_indexes_son(j,5)=1;
                                    elseif num_cop(j)==2
                                     matrix_indexes_son(j,5)=1;
                                    elseif num_cop(j)==3
                                     matrix_indexes_son(j,6)=1; 
                                    elseif num_cop(j)==4 
                                     matrix_indexes_son(j,7)=1; 
                                    elseif num_cop(j)==5
                                     matrix_indexes_son(j,7)=1;
                                    elseif num_cop(j)==6
                                     matrix_indexes_son(j,8)=1;                                        
                                    elseif num_cop(j)==7
                                     matrix_indexes_son(j,5)=1; 
                                     matrix_indexes_son(j,6)=1; 
                                    elseif num_cop(j)==8
                                     matrix_indexes_son(j,7)=1; 
                                     matrix_indexes_son(j,8)=1; 
                                     elseif num_cop(j)==9
                                      % Do nothing
                                     elseif num_cop(j)==10
                                      % Do nothing
                                    end                                     
                            elseif pos(matrix_indexes_son(j,2),2)==1                                                       % NY-NNN
                                    if num_cop(j)==1
                                     matrix_indexes_son(j,5)=1;
                                    elseif num_cop(j)==2
                                     matrix_indexes_son(j,6)=1;
                                    elseif num_cop(j)==3
                                     matrix_indexes_son(j,6)=1; 
                                    elseif num_cop(j)==4 
                                     matrix_indexes_son(j,7)=1; 
                                    elseif num_cop(j)==5
                                     matrix_indexes_son(j,8)=1;
                                    elseif num_cop(j)==6
                                     matrix_indexes_son(j,8)=1;                                        
                                    elseif num_cop(j)==7
                                     matrix_indexes_son(j,5)=1; 
                                     matrix_indexes_son(j,6)=1; 
                                    elseif num_cop(j)==8
                                     matrix_indexes_son(j,7)=1; 
                                     matrix_indexes_son(j,8)=1; 
                                     elseif num_cop(j)==9
                                      % Do nothing
                                     elseif num_cop(j)==10
                                      % Do nothing
                                    end
                            end
                  end

             elseif sum_Y==0   % (4 N's)
                  if pos(matrix_indexes_son(j,2),3)==1 &&  pos(matrix_indexes_son(j,4),3)==1     % Check if we're in case NNC-NNC      
                      if num_cop(j)==1
                          matrix_indexes_son(j,5:8)=[1;1;1;1];
                      elseif num_cop(j)==2
                          matrix_indexes_son(j,5:8)=[0;0;0;0];
                      elseif num_cop(j)==3
                          matrix_indexes_son(j,5:8)=[0;0;0;0];
                      elseif num_cop(j)==4
                          matrix_indexes_son(j,5:8)=[0;0;0;0];
                      elseif num_cop(j)==5
                          matrix_indexes_son(j,5:8)=[0;0;0;0];
                      end
                	elseif pos(matrix_indexes_son(j,2),3)+pos(matrix_indexes_son(j,4),3)==1       % Check if we're in case NNC-NNN (or viceversa)
                         if pos(matrix_indexes_son(j,2),3)==1                               % Case NNC-NNN 
                                    if num_cop(j)==1
                                    matrix_indexes_son(j,5)=1;
                                    matrix_indexes_son(j,8)=1;
                                    elseif num_cop(j)==2
                                    matrix_indexes_son(j,5)=1;
                                    matrix_indexes_son(j,8)=1;
                                    elseif num_cop(j)==3
                                    matrix_indexes_son(j,6)=1;
                                    matrix_indexes_son(j,7)=1; 
                                    elseif num_cop(j)==4
                                    matrix_indexes_son(j,6)=1;
                                    matrix_indexes_son(j,7)=1; 
                                    elseif num_cop(j)>4        % ...until 10.
                                     % Do nothing                               
                                    end
                         elseif pos(matrix_indexes_son(j,4),3)==1                               % Case NNN-NNC
                                    if num_cop(j)==1
                                    matrix_indexes_son(j,5)=1;
                                    matrix_indexes_son(j,7)=1;
                                    elseif num_cop(j)==2
                                    matrix_indexes_son(j,5)=1;
                                    matrix_indexes_son(j,7)=1;
                                    elseif num_cop(j)==3
                                    matrix_indexes_son(j,6)=1;
                                    matrix_indexes_son(j,8)=1;
                                    elseif num_cop(j)==4
                                    matrix_indexes_son(j,6)=1;
                                    matrix_indexes_son(j,8)=1;   
                                    elseif num_cop(j)>4       % ...until 10.
                                        % Do nothing
                                    end  
                         end
                elseif pos(matrix_indexes_son(j,2),3)+pos(matrix_indexes_son(j,4),3)==0       % Then we are in case NNN-NNN
                    
                    if num_cop(j)==1
                      matrix_indexes_son(j,5:8)=[1;0;0;0];   
                    elseif num_cop(j)==2
                      matrix_indexes_son(j,5:8)=[1;0;0;0];   
                    elseif num_cop(j)==3
                      matrix_indexes_son(j,5:8)=[1;0;0;0];   
                    elseif num_cop(j)==4
                      matrix_indexes_son(j,5:8)=[1;0;0;0];  
                    elseif num_cop(j)==5
                      matrix_indexes_son(j,5:8)=[0;1;0;0];                   
                    elseif num_cop(j)==6
                      matrix_indexes_son(j,5:8)=[0;1;0;0];                  
                    elseif num_cop(j)==7
                      matrix_indexes_son(j,5:8)=[0;1;0;0];                   
                    elseif num_cop(j)==8
                      matrix_indexes_son(j,5:8)=[0;1;0;0]; 
                    elseif num_cop(j)==9
                      matrix_indexes_son(j,5:8)=[0;0;1;0];             
                    elseif num_cop(j)==10
                      matrix_indexes_son(j,5:8)=[0;0;1;0];            
                    elseif num_cop(j)==11
                      matrix_indexes_son(j,5:8)=[0;0;1;0];             
                    elseif num_cop(j)==12
                      matrix_indexes_son(j,5:8)=[0;0;1;0];  
                    elseif num_cop(j)==13
                      matrix_indexes_son(j,5:8)=[0;0;0;1]; 
                    elseif num_cop(j)==14
                      matrix_indexes_son(j,5:8)=[0;0;0;1];    
                    elseif num_cop(j)==15
                      matrix_indexes_son(j,5:8)=[0;0;0;1]; 
                    elseif num_cop(j)==16
                      matrix_indexes_son(j,5:8)=[0;0;0;1]; 
                    elseif num_cop(j)==17
                      matrix_indexes_son(j,5:8)=[1;1;0;0];                   
                    elseif num_cop(j)==18
                      matrix_indexes_son(j,5:8)=[0;0;1;1];                  
                    elseif num_cop(j)>18                   % ..until 27.
                      matrix_indexes_son(j,5:8)=[0;0;0;0];             
                    end           
                  end
              end
      end
% 4) Now ADD x9, x10, x11 and x12:      
     matrix_indexes_son= [matrix_indexes_son 999*ones(length,4)];
     for j=1:length
                % First replace all standard elements
                if pos(matrix_indexes_son(j,2),1)==1 || (matrix_indexes_son(j,5)+pos(matrix_indexes_son(j,4),1))==1 ...
                                                     || (matrix_indexes_son(j,7)+pos(matrix_indexes_son(j,4),2))==1
                matrix_indexes_son(j,9)=0;    
                elseif (matrix_indexes_son(j,5)+pos(matrix_indexes_son(j,4),1))==2 || (matrix_indexes_son(j,7)+pos(matrix_indexes_son(j,4),2))==2
                matrix_indexes_son(j,9)=1;    
                end
                
                if pos(matrix_indexes_son(j,2),2)==1 || (matrix_indexes_son(j,6)+pos(matrix_indexes_son(j,4),2))==1 ...
                                                     || (matrix_indexes_son(j,8)+pos(matrix_indexes_son(j,4),1))==1
                matrix_indexes_son(j,10)=0;    
                elseif (matrix_indexes_son(j,6)+pos(matrix_indexes_son(j,4),2))==2 || (matrix_indexes_son(j,8)+pos(matrix_indexes_son(j,4),1))==2
                matrix_indexes_son(j,10)=1;    
                end
                matrix_indexes_son(j,11) = (matrix_indexes_son(j,5)*(pos(matrix_indexes_son(j,2),1)==1) + (matrix_indexes_son(j,8)*(pos(matrix_indexes_son(j,2),2)==1)) >=1);
                matrix_indexes_son(j,12) = (matrix_indexes_son(j,7)*(pos(matrix_indexes_son(j,2),1)==1) + (matrix_indexes_son(j,6)*(pos(matrix_indexes_son(j,2),2)==1)) >=1);
                
                % Now replace all copies (non-standard elements)
                   % check how many 0's:
        sum_Y=sum_pos(matrix_indexes_son(j,2))+sum_pos(matrix_indexes_son(j,4));
        
           if sum_Y==1   % (3 N's)
                 if pos(matrix_indexes_son(j,2),3)==1                                            % Check if we're in case NNC - ...
                        if pos(matrix_indexes_son(j,4),2)==0                                     % Case NNC-YN
                                  if num_cop(j)==2
                                     matrix_indexes_son(j,12)=1;
                                  elseif num_cop(j)==4
                                     matrix_indexes_son(j,12)=1;
                                  else
                                     % Do nothing
                                  end                                    
                             
                        elseif pos(matrix_indexes_son(j,4),1)==0                                 % Case NNC-NY      
                                  if num_cop(j)==2
                                     matrix_indexes_son(j,11)=1;
                                  elseif num_cop(j)==4
                                     matrix_indexes_son(j,11)=1;
                                  else
                                     % Do nothing
                                  end                               
                            
                        end
                 elseif pos(matrix_indexes_son(j,4),3)==1                                        % Check if we're in case ... - NNC    
                        if pos(matrix_indexes_son(j,2),2)==0                                    % Case YN-NNC
                                  if num_cop(j)==1
                                     matrix_indexes_son(j,10)=1;
                                  elseif num_cop(j)==2
                                     matrix_indexes_son(j,10)=0;
                                  elseif num_cop(j)==4
                                     matrix_indexes_son(j,10)=1;
                                  elseif num_cop(j)==5
                                     matrix_indexes_son(j,10)=0;
                                  end                          
                            
                        end
                        if pos(matrix_indexes_son(j,2),1)==0                                    % Case NY-NNC
                                  if num_cop(j)==2
                                     matrix_indexes_son(j,9)=1;
                                  elseif num_cop(j)==3
                                     matrix_indexes_son(j,9)=0;
                                  elseif num_cop(j)==4
                                     matrix_indexes_son(j,9)=1;
                                  elseif num_cop(j)==5
                                     matrix_indexes_son(j,9)=0;
                                  end                              
                            
                        end                             
                 elseif pos(matrix_indexes_son(j,2),1)==0  && pos(matrix_indexes_son(j,2),2)==0  && pos(matrix_indexes_son(j,2),3)==0    % Case NNN-...
                        if pos(matrix_indexes_son(j,4),2)==0                                     % Case NNN-YN
                                  if num_cop(j)==1
                                     matrix_indexes_son(j,12)=1;
                                  elseif num_cop(j)==6
                                     matrix_indexes_son(j,12)=1;
                                  elseif num_cop(j)==9
                                     matrix_indexes_son(j,12)=1;
                                  else
                                     % Do nothing
                                  end                                    
                             
                        elseif pos(matrix_indexes_son(j,4),1)==0                                 % Case NNN-NY      
                                  if num_cop(j)==2
                                     matrix_indexes_son(j,11)=1;
                                  elseif num_cop(j)==4
                                     matrix_indexes_son(j,11)=1;
                                  elseif num_cop(j)==9
                                     matrix_indexes_son(j,11)=1;
                                  else
                                     % Do nothing
                                  end                               
                            
                        end                     
                 elseif pos(matrix_indexes_son(j,4),1)==0  && pos(matrix_indexes_son(j,4),2)==0  && pos(matrix_indexes_son(j,4),3)==0    % Case ...-NNN                      
                            if pos(matrix_indexes_son(j,2),1)==1                                                       % YN-NNN
                                    if num_cop(j)==1
                                     matrix_indexes_son(j,10)=1;
                                    elseif num_cop(j)==2
                                     matrix_indexes_son(j,10)=0;
                                    elseif num_cop(j)==4 
                                     matrix_indexes_son(j,10)=1; 
                                    elseif num_cop(j)==5
                                     matrix_indexes_son(j,10)=0;
                                    elseif num_cop(j)==9
                                     matrix_indexes_son(j,10)=1;
                                    elseif num_cop(j)==10
                                     matrix_indexes_son(j,10)=0;
                                    end                                     
                            elseif pos(matrix_indexes_son(j,2),2)==1                                                       % NY-NNN
                                    if num_cop(j)==2
                                     matrix_indexes_son(j,9)=1;
                                    elseif num_cop(j)==3
                                     matrix_indexes_son(j,9)=0; 
                                    elseif num_cop(j)==5
                                     matrix_indexes_son(j,9)=1;
                                    elseif num_cop(j)==6
                                     matrix_indexes_son(j,9)=0;                                        
                                    elseif num_cop(j)==9
                                     matrix_indexes_son(j,9)=1;
                                    elseif num_cop(j)==10
                                     matrix_indexes_son(j,9)=0;
                                    end  
                            end
                    end
             elseif sum_Y==0   % (4 N's)
                  if pos(matrix_indexes_son(j,2),3)==1 &&  pos(matrix_indexes_son(j,4),3)==1     % Check if we're in case NNC-NNC      
                     if num_cop(j)==2
                          matrix_indexes_son(j,9:12)=[1 1 1 1];
                     elseif num_cop(j)==3
                          matrix_indexes_son(j,9:12)=[1 1 0 0];
                      elseif num_cop(j)==4
                          matrix_indexes_son(j,9:12)=[0 0 1 1];
                      elseif num_cop(j)==5
                          matrix_indexes_son(j,9:12)=[0 0 0 0];
                     end
                 elseif pos(matrix_indexes_son(j,2),3)+pos(matrix_indexes_son(j,4),3)==1       % Check if we're in case NNC-NNN (or viceversa)
                         if pos(matrix_indexes_son(j,2),3)==1                               % Case NNC-NNN 
                                    if num_cop(j)==1
                                     matrix_indexes_son(j,9:12)=[0 0 0 1];
                                    elseif num_cop(j)==3
                                     matrix_indexes_son(j,9:12)=[0 0 1 0];                                   
                                    elseif num_cop(j)==5
                                     matrix_indexes_son(j,9:12)=[1 1 1 0];
                                    elseif num_cop(j)==6
                                     matrix_indexes_son(j,9:12)=[1 1 0 1];
                                    elseif num_cop(j)==7
                                     matrix_indexes_son(j,9:12)=[1 1 0 0];
                                    elseif num_cop(j)==8
                                     matrix_indexes_son(j,9:12)=[0 0 1 0];
                                    elseif num_cop(j)==9
                                     matrix_indexes_son(j,9:12)=[0 0 0 1];
                                    elseif num_cop(j)==10
                                     matrix_indexes_son(j,9:12)=[0 0 0 0];
                                    end
                         elseif pos(matrix_indexes_son(j,4),3)==1                               % Case NNN-NNC
                                    if num_cop(j)==1
                                    matrix_indexes_son(j,10)=1;
                                    elseif num_cop(j)==2
                                    matrix_indexes_son(j,10)=0;
                                    elseif num_cop(j)==3
                                    matrix_indexes_son(j,9)=1;
                                    elseif num_cop(j)==4
                                    matrix_indexes_son(j,9)=0;  
                                    elseif num_cop(j)==5
                                    matrix_indexes_son(j,9:12)=[1 0 1 1]; 
                                    elseif num_cop(j)==6
                                    matrix_indexes_son(j,9:12)=[1 0 0 0]; 
                                    elseif num_cop(j)==7
                                    matrix_indexes_son(j,9:12)=[0 1 1 1]; 
                                    elseif num_cop(j)==8
                                    matrix_indexes_son(j,9:12)=[0 1 0 0]; 
                                    elseif num_cop(j)==9
                                    matrix_indexes_son(j,9:12)=[0 0 1 1]; 
                                    elseif num_cop(j)==10
                                    matrix_indexes_son(j,9:12)=[0 0 0 0]; 
                                    end  
                         end
                elseif pos(matrix_indexes_son(j,2),3)+pos(matrix_indexes_son(j,4),3)==0       % Then we are in case NNN-NNN
                    
                    if num_cop(j)==1
                      matrix_indexes_son(j,10)=1;
                      matrix_indexes_son(j,12)=1; 
                    elseif num_cop(j)==2
                      matrix_indexes_son(j,10)=1;
                      matrix_indexes_son(j,12)=0;    
                    elseif num_cop(j)==3
                      matrix_indexes_son(j,10)=0;
                      matrix_indexes_son(j,12)=1; 
                    elseif num_cop(j)==4
                      matrix_indexes_son(j,10)=0;
                      matrix_indexes_son(j,12)=0;
                    elseif num_cop(j)==5
                      matrix_indexes_son(j,9)=1;
                      matrix_indexes_son(j,11)=1; 
                    elseif num_cop(j)==6
                      matrix_indexes_son(j,9)=1;
                      matrix_indexes_son(j,11)=0;    
                    elseif num_cop(j)==7
                      matrix_indexes_son(j,9)=0;
                      matrix_indexes_son(j,11)=1; 
                    elseif num_cop(j)==8
                      matrix_indexes_son(j,9)=0;
                      matrix_indexes_son(j,11)=0; 
                    elseif num_cop(j)==9
                      matrix_indexes_son(j,10)=1;
                      matrix_indexes_son(j,11)=1; 
                    elseif num_cop(j)==10
                      matrix_indexes_son(j,10)=1;
                      matrix_indexes_son(j,11)=0;    
                    elseif num_cop(j)==11
                      matrix_indexes_son(j,10)=0;
                      matrix_indexes_son(j,11)=1; 
                    elseif num_cop(j)==12
                      matrix_indexes_son(j,10)=0;
                      matrix_indexes_son(j,11)=0;
                    elseif num_cop(j)==13
                      matrix_indexes_son(j,9)=1;
                      matrix_indexes_son(j,12)=1; 
                    elseif num_cop(j)==14
                      matrix_indexes_son(j,9)=1;
                      matrix_indexes_son(j,12)=0;    
                    elseif num_cop(j)==15
                      matrix_indexes_son(j,9)=0;
                      matrix_indexes_son(j,12)=1; 
                    elseif num_cop(j)==16
                      matrix_indexes_son(j,9)=0;
                      matrix_indexes_son(j,12)=0; 
                    elseif num_cop(j)==19
                      matrix_indexes_son(j,9:12)=[1 0 1 0];    
                    elseif num_cop(j)==20
                      matrix_indexes_son(j,9:12)=[1 0 0 1];  
                    elseif num_cop(j)==21
                      matrix_indexes_son(j,9:12)=[1 0 0 0];  
                    elseif num_cop(j)==22
                      matrix_indexes_son(j,9:12)=[0 1 1 0];    
                    elseif num_cop(j)==23
                      matrix_indexes_son(j,9:12)=[0 1 0 1];  
                    elseif num_cop(j)==24
                      matrix_indexes_son(j,9:12)=[0 1 0 0];  
                    elseif num_cop(j)==25
                      matrix_indexes_son(j,9:12)=[0 0 1 0];    
                    elseif num_cop(j)==26
                      matrix_indexes_son(j,9:12)=[0 0 0 1];  
                    elseif num_cop(j)==27
                      matrix_indexes_son(j,9:12)=[0 0 0 0];  
                    end       
                end
            end
     end
 matrix_indexes_son_HF1=matrix_indexes_son; 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 
 % Now put together the 2 matrices:

 % Put aside rest of the state (HC, NET, E.S.)
 %[j1, j2, j3, j4, j5]=ind2sub([n_hc n_net n_hc n_net n_es],1:n_hc*n_net*n_hc*n_net*n_es);
 [j1, j2, j3, j4, j5]=ind2sub([n_hc n_net n_es n_hc n_net],1:n_hc*n_net*n_hc*n_net*n_es);
 rest_of_state=[j1' j2' j3' j4' j5'];
 matrix_indexes_son_HFall=[matrix_indexes_son_HF0(:,2:12);matrix_indexes_son_HF1(:,2:12)];
 length=size(matrix_indexes_son_HFall,1);
 matrix_indexes_son=[repmat(matrix_indexes_son_HFall,n_hc*n_net*n_hc*n_net*n_es,1) kron(rest_of_state,ones(length,1))];
 length=size(matrix_indexes_son,1);
 
    % Back out father's state position
    pos_fat=999*ones(length,1);
 for j=1:length
    pos_fat(j)=find(ismember(matrix_indexes_father,[matrix_indexes_son(j,3) matrix_indexes_son(j,12) matrix_indexes_son(j,13)],'rows'));
 end
    % Now reorganize state (reduce it to 12 variables, with father in only
    % one cell)
 matrix_indexes_son=[matrix_indexes_son(:,1:2) pos_fat matrix_indexes_son(:,4:11) matrix_indexes_son(:,14:16)];
 
         % Replace FH with a dummy
 matrix_indexes_son(:,2)=matrix_indexes_son(:,2)+(ones(length,1)-matrix_indexes_son(:,2)).*(matrix_indexes_son(:,2)==1);
 matrix_indexes_son(:,2)=matrix_indexes_son(:,2)+(zeros(length,1)-matrix_indexes_son(:,2)).*(matrix_indexes_son(:,2)==2);    

 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %%%%%%%%%%%%%% CONSTRUCTION OF "WHERETOLOOK" MATRIX %%%%%%%%%%%%%%%%%%%%%%
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
 % Start from the "small" matrix (neglecting HC and NET)
 matrix_indexes_son_small=matrix_indexes_son(1:length/(n_hc*n_net),:);
 length_small=length/(n_hc*n_net);
 unique_occ=zeros(length_small,length_small);
 %tot_unique_occ=zeros(length_small,1);
 for j=1:length_small
     for k=1:length_small
        unique_occ(j,k)=(matrix_indexes_son(j,3)==matrix_indexes_son(k,3))* ...
                        (matrix_indexes_son(j,4)==matrix_indexes_son(k,4))* ...
                        (matrix_indexes_son(j,5)==matrix_indexes_son(k,5))* ...
                        (matrix_indexes_son(j,6)==matrix_indexes_son(k,6))* ...
                        (matrix_indexes_son(j,7)==matrix_indexes_son(k,7))* ...
                        (matrix_indexes_son(j,8)==matrix_indexes_son(k,8))* ...
                        (matrix_indexes_son(j,9)==matrix_indexes_son(k,9))* ...
                        (matrix_indexes_son(j,12)==matrix_indexes_son(k,12))*...
                        ((matrix_indexes_son(j,1)==1)*(matrix_indexes_son(k,1)==1 || matrix_indexes_son(k,1)==4)+...
                        (matrix_indexes_son(j,1)==2)*(matrix_indexes_son(k,1)==2 || matrix_indexes_son(k,1)==3 || matrix_indexes_son(k,1)==5)+...
                        (matrix_indexes_son(j,1)==3)*(matrix_indexes_son(k,1)==2 || matrix_indexes_son(k,1)==3 || matrix_indexes_son(k,1)==5)+...
                        (matrix_indexes_son(j,1)==4)*(matrix_indexes_son(k,1)==1 || matrix_indexes_son(k,1)==4)+...
                        (matrix_indexes_son(j,1)==5)*(matrix_indexes_son(k,1)==2 || matrix_indexes_son(k,1)==3 || matrix_indexes_son(k,1)==5))*...
                        (1-(j==k));

     end
     %tot_unique_occ(j)=sum(unique_occ(j,:));
 end
 tot_unique_occ=sum(unique_occ,2);
 
 wheretolook_son=999*ones(length_small,n_occ-1);
 for j=1:length_small
                          % Find code of anonymous occ.
                        anon_occ=matrix_indexes_son_small(j,:);
                            % Select cell with nothing!
                            if anon_occ(1)==1
                                anon_occ(1)=4;
                            elseif anon_occ(1)==2 || anon_occ(1)==3
                                anon_occ(1)=5;
                            end
                            if anon_occ(2)==1
                                anon_occ(2)=0;
                            end     
                            if anon_occ(10)==1 || anon_occ(11)==1
                                anon_occ(10)=0; anon_occ(11)=0;
                            end                                 
                            code_anon_occ=find(ismember(matrix_indexes_son_small,anon_occ,'rows'));                            
                            
    list_of_occ=find(unique_occ(j,:)==1);
        for i=1:tot_unique_occ(j)
           wheretolook_son(j,i)=list_of_occ(i); 
        end
        for i=tot_unique_occ(j)+1:n_occ-1
            wheretolook_son(j,i)=code_anon_occ;
        end
 end
 
 wheretolook_son=[[1:length]' repmat(wheretolook_son,n_hc*n_net,1)];
 
 
save(sprintf('base_cal/state_sons_built_nhc%g.mat',n_hc),'matrix_indexes_son','wheretolook_son','pos','sum_pos');
 
end
 

 
 
 