function [ output_args ] = figure_explain_prob_choosing( alreadydone )
%This function produces the figure that explains how workers choose one
%occupation or another when they have tradeoffs.
if nargin < 1, alreadydone=0; end %default: change everything

if alreadydone == 0
    load results/calibration_results_3hc_9occ paramout
    write_parameters(paramout)
    model_sons;
end

load base_cal/parameters_model.mat
load(sprintf('base_cal/state_sons_built_nhc%g.mat',n_hc));
load base_cal/sons.mat u_state_sons prob_choosing_occ

selectthesample_for2_nofather=(matrix_indexes_son(:,1)==5).*(matrix_indexes_son(:,2)==0).*(matrix_indexes_son(:,8)==0);
selectthesample_for3_nofather=(matrix_indexes_son(:,1)==5).*(matrix_indexes_son(:,2)==0).*(matrix_indexes_son(:,9)==0);
selectthesample_for2_father=(matrix_indexes_son(:,1)==5).*(matrix_indexes_son(:,2)==0).*(matrix_indexes_son(:,8)==1);
selectthesample_for3_father=(matrix_indexes_son(:,1)==5).*(matrix_indexes_son(:,2)==0).*(matrix_indexes_son(:,9)==1);
selectthesample_for5=(matrix_indexes_son(:,1)==5).*(matrix_indexes_son(:,2)==0).*...
    (matrix_indexes_son(:,8)==0).*(matrix_indexes_son(:,9)==0);

wheretoocc=wheretolook_son;
wheretofather=zeros(statesize_son,n_occ);
for k=1:statesize_son
    wheretoocc(k,:)=matrix_indexes_son(wheretolook_son(k,:),1);
    wheretofather(k,:)=matrix_indexes_son(wheretolook_son(k,:),2);
end


howmanychange=u_state_sons';

%GRAPH TO EXPORT - DIFFERENCE IN PROB. OF CHOOSING OCC. BY
%FATHER'S POSITION
prob_2_nofather=sum(sum(prob_choosing_occ.*(wheretoocc==2),2).*(howmanychange).*selectthesample_for2_nofather)/ ...
    sum(howmanychange.*selectthesample_for2_nofather);
prob_3_nofather=sum(sum(prob_choosing_occ.*(wheretoocc==3),2).*(howmanychange).*selectthesample_for3_nofather)/ ...
    sum(howmanychange.*selectthesample_for3_nofather);

prob_2_father=sum(sum(prob_choosing_occ.*(wheretoocc==2),2).*(howmanychange).*selectthesample_for2_father)/ ...
    sum(howmanychange.*selectthesample_for2_father);
prob_3_father=sum(sum(prob_choosing_occ.*(wheretoocc==3),2).*(howmanychange).*selectthesample_for3_father)/ ...
    sum(howmanychange.*selectthesample_for3_father);

alltheotherprobchoosingocc_withfather=prob_choosing_occ.*(wheretoocc==5 & wheretofather==1);
alltheotherprobchoosingocc=prob_choosing_occ.*(wheretoocc==5 & wheretofather==0);
prob_5_nofather=sum((sum(alltheotherprobchoosingocc(:,2:end),2)./(n_occ-4)).*(u_state_sons').*selectthesample_for5)/ ...
    sum(u_state_sons'.*selectthesample_for5);
prob_5_father=sum(sum(alltheotherprobchoosingocc_withfather,2).*(u_state_sons').*selectthesample_for5)/ ...
    sum(u_state_sons'.*selectthesample_for5);

x=categorical({'Choose Adv \\ no father','Choose Adv, \n father';'Choose Pref, \n no father','Choose Pref, \n father';'Choose nothing, \n no father','Choose nothing, \n father'});
x=reordercats(categorical({'Choose Adv','Choose Pref','Choose Other Occ.'}),{'Choose Adv','Choose Pref','Choose Other Occ.'});
y=[prob_2_father prob_2_nofather ; prob_3_father prob_3_nofather ; prob_5_father prob_5_nofather ];

fig1=figure(1);
hb=bar(x,y);
hb(1).FaceColor = 'red';
hb(2).FaceColor = 'cyan';
legend(hb,'Father in that Occ.','Father in other Occ.');
saveas(fig1,'figures/probchoosingocc_byfather.eps');
y




%LESS INTERESTING GRAPH - DIFFERENCE IN PROB. OF CHOOSING OCC. BY
%FATHER'S POSITION FOR COINCIDE TYPES
selectthesample_for1_nofather=(matrix_indexes_son(:,1)==4).*(matrix_indexes_son(:,2)==0).*(matrix_indexes_son(:,8)==0);
selectthesample_for1_father=(matrix_indexes_son(:,1)==4).*(matrix_indexes_son(:,2)==0).*(matrix_indexes_son(:,8)==1);
selectthesample_for4=(matrix_indexes_son(:,1)==4).*(matrix_indexes_son(:,2)==0).*...
    (matrix_indexes_son(:,8)==0);



prob_1_nofather=sum(sum(prob_choosing_occ.*(wheretoocc==1),2).*(howmanychange).*selectthesample_for1_nofather)/ ...
    sum(howmanychange.*selectthesample_for1_nofather);
prob_1_father=sum(sum(prob_choosing_occ.*(wheretoocc==1),2).*(howmanychange).*selectthesample_for1_father)/ ...
    sum(howmanychange.*selectthesample_for1_father);

alltheotherprobchoosingocc_withfather=prob_choosing_occ.*(wheretoocc==4 & wheretofather==1);
alltheotherprobchoosingocc=prob_choosing_occ.*(wheretoocc==4 & wheretofather==0);
prob_4_nofather=sum((sum(alltheotherprobchoosingocc(:,2:end),2)./(n_occ-4)).*(u_state_sons').*selectthesample_for4)/ ...
    sum(u_state_sons'.*selectthesample_for4);
prob_4_father=sum(sum(alltheotherprobchoosingocc_withfather,2).*(u_state_sons').*selectthesample_for4)/ ...
    sum(u_state_sons'.*selectthesample_for4);

x=reordercats(categorical({'Choose Adv and Pref','Choose Other Occ.'}),{'Choose Adv and Pref','Choose Other Occ.'});
y=[prob_1_father prob_1_nofather ; prob_4_father prob_4_nofather ];

fig2=figure(2);
hb2=bar(x,y);
hb2(1).FaceColor = 'red';
hb2(2).FaceColor = 'cyan';
legend(hb2,'Father in that Occ.','Father in other Occ.');
saveas(fig2,'figures/probchoosingocc_coincide_byfather.eps');
y

end

